import os
from string import Template
import logging
import pkg_resources
class WithMinusTemplate(Template):
  __module__ = __name__
  idpattern = '[_a-z][-_a-z0-9]*'

class Recipe(object):
  __module__ = __name__

  def __init__(self, buildout, name, options):
    self.options,self.name,self.buildout = options,name,buildout
    self.logger = logging.getLogger(self.name)

  def install_configuration(self):
    template_file = self.options.get('oood_conf_template', '').strip()
    if template_file:
      template_input_data = file(template_file).read()
    else:
      template_input_data = pkg_resources.resource_stream(__name__,
          'oood.conf.in').read()
    file(self.options['oood_conf_file'], 'w').write(WithMinusTemplate(
      template_input_data).substitute(self.buildout[
        self.options['configuration_part']].copy()))
    self.logger.info(('Installed configuration %r.' %
      self.options['oood_conf_file']))

  def install_wrapper(self):
    template_file = self.options.get('oood_wrapper_template', '').strip()
    if template_file:
      template_input_data = file(template_file).read()
    else:
      template_input_data = pkg_resources.resource_stream(__name__,
          'oood-runserw.in').read()
    file(self.options['wrapper_path'], 'w').write(WithMinusTemplate(
      template_input_data).substitute(self.buildout[
        self.options['wrapper_part']].copy()))
    os.chmod(self.options['wrapper_path'], 0755)
    self.logger.info(('Installed wrapper %r.' % self.options['wrapper_path']))

  def install(self):
    self.install_configuration()
    self.install_wrapper()
    return []

  update = install
